#define STRICT
#include <Windows.h>
#include "PCAD2.h"
#include "resource.h"

HANDLE hCard = INVALID_HANDLE_VALUE;
unsigned CurrentInputs;
HBRUSH YellowBrush;
HBRUSH GreyBrush;

INT_PTR CALLBACK DialogProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
		case WM_INITDIALOG:
			YellowBrush = CreateSolidBrush (RGB (255, 255, 0));
			GreyBrush = CreateSolidBrush (RGB (120, 120, 120));
			SetDlgItemText (hwnd, INPUT_1, L"Input 1");
			SetDlgItemText (hwnd, INPUT_2, L"Input 2");
			hCard = PCAD2Open (0);
			if (hCard != INVALID_HANDLE_VALUE) SetTimer (hwnd, 1, 100, NULL);
			return TRUE;
		case WM_TIMER:
			if (wParam == 1) {
				unsigned NewInputs = PCAD2GetGPI (hCard);
				if ((NewInputs ^ CurrentInputs) & 1) InvalidateRect (GetDlgItem (hwnd, INPUT_1), NULL, FALSE);
				if ((NewInputs ^ CurrentInputs) & 2) InvalidateRect (GetDlgItem (hwnd, INPUT_2), NULL, FALSE);
				CurrentInputs = NewInputs;
				unsigned Outputs = 0;
				if (SendDlgItemMessage (hwnd, OUTPUT_1, BM_GETSTATE, 0, 0) & BST_PUSHED) Outputs |= 1;
				if (SendDlgItemMessage (hwnd, OUTPUT_2, BM_GETSTATE, 0, 0) & BST_PUSHED) Outputs |= 2;
				PCAD2SetGPO (hCard, Outputs);
			}
			return TRUE;
		case WM_CTLCOLORSTATIC:
			{
				HDC hdc = (HDC) wParam;
				HWND hControl = (HWND) lParam;
				LONG Id = (LONG) GetWindowLongPtr (hControl, GWL_ID);
				switch (Id) {
					case INPUT_1:
						SetBkColor (hdc, (CurrentInputs & 1) ? RGB (255, 255, 0) : RGB (120, 120, 120));
						return INT_PTR ((CurrentInputs & 1) ? YellowBrush : GreyBrush);
					case INPUT_2:
						SetBkColor (hdc, (CurrentInputs & 2) ? RGB (255, 255, 0) : RGB (120, 120, 120));
						return INT_PTR ((CurrentInputs & 2) ? YellowBrush : GreyBrush);
					default:
						return FALSE;
				}
			}
		case WM_CLOSE:
			KillTimer (hwnd, 100);
			if (hCard != INVALID_HANDLE_VALUE) CloseHandle (hCard);
			DeleteObject (GreyBrush);
			DeleteObject (YellowBrush);
			EndDialog (hwnd, 0);
			return TRUE;
		default:
			return FALSE;
	}
}


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE, LPSTR, int cmdshow) {
	DialogBox (hInstance, L"GPIO_DEMO", NULL, DialogProc);
	return 0;
}